import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class RabattPanel13 extends JPanel implements ActionListener {
private JTextField betragFeld  = new JTextField( 7);
private JTextField rabattFeld  = new JTextField( 7);
private JTextField ausgabeFeld = new JTextField( 7);

 void setBetrag( float value) {
  betragFeld.setText( ""+value);
 }

 void setRabatt( float value) {
  rabattFeld.setText( ""+value);
 }

 private float valueOf( String text) {
 Float zahl = null;

  try   {
         zahl = new Float( text);
        }
  catch (NumberFormatException nfe)
        {
         System.out.println( "Unkorrekte Eingabe.");
         System.exit( 1);
        }
  return zahl.floatValue();
 }

 float calculate() {
 float betragWert = valueOf( betragFeld.getText());
 float rabattWert = valueOf( rabattFeld.getText());

  return betragWert * (1 - rabattWert / 100);
 }

 private boolean inputOk( String input) {
 Float zahl = null;
  try   {
         zahl = new Float( input);
        }
  catch (NumberFormatException nfe)
        {
         return false;
        }
  return true;
 }

  private void setColor( JTextField field, boolean error) {
   if (error)
      {
       field.setBackground( Color.red);
       field.setForeground( Color.yellow);
       return;
      }
   field.setBackground( Color.white);
   field.setForeground( Color.black);
  }

 public void actionPerformed( ActionEvent ae) {
 JTextField requesterror = null;
 JTextField requestempty = null;

  ausgabeFeld.setText( "");
  if (!inputOk(betragFeld.getText()))
     {
      if   (betragFeld.getText().length() < 1)
           {
            setColor( betragFeld, false);
            requestempty = betragFeld;
           }
      else {
            setColor( betragFeld, true);
            requesterror = betragFeld;
           }
     }
  if (!inputOk(rabattFeld.getText()))
     {
      if   (rabattFeld.getText().length() < 1)
           {
            setColor( rabattFeld, false);
            if ((requestempty == null) &&
                (requesterror == null))
                requestempty = rabattFeld;
           }
      else {
            setColor( rabattFeld, true);
            if (requesterror == null)
                requesterror = rabattFeld;
           }
     }
  if (requesterror != null)
     {
      requesterror.requestFocus();
      return;
     }
  if (requestempty != null)
     {
      requestempty.requestFocus();
      return;
     }
  setColor( betragFeld, false);
  setColor( rabattFeld, false);
  ausgabeFeld.setText( ""+calculate());
  betragFeld.requestFocus();
 }

 RabattPanel13() {
 JPanel fields = new JPanel();
  fields.setLayout( new BorderLayout());
  fields.add( betragFeld,  BorderLayout.NORTH);
  fields.add( rabattFeld,  BorderLayout.CENTER);
  fields.add( ausgabeFeld, BorderLayout.SOUTH);

 JPanel labels = new JPanel();
  labels.setLayout( new BorderLayout());
  labels.add( new JLabel( "Betrag"), BorderLayout.NORTH);
  labels.add( new JLabel( "Rabatt"), BorderLayout.CENTER);
  labels.add( new JLabel( "Endbetrag"), BorderLayout.SOUTH);

  this.setLayout( new BorderLayout());
  this.add( labels, BorderLayout.WEST);
  this.add( fields, BorderLayout.EAST);

JButton button = new JButton( "berechnen");
  button.addActionListener( this);
  this.add( button, BorderLayout.SOUTH);
 }
}